diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
index bc0e9d198..43db58db0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorBar.java
@@ -21,14 +21,14 @@ public class HudComponentArmorBar
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.playerController.canHurtPlayer() && mc.gameSettings.immersiveMode.drawHotbar() && mc.thePlayer.getPlayerProtectionAmount() > 0;
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
@@ -38,7 +38,7 @@ public class HudComponentArmorBar
         for (int i = 0; i < 10; i++) {
             if (armorValue > 0)
             {
-                int xArmor = x + getXSize(mc) - i * 8 - 9;
+                int xArmor = x + getXSize() - i * 8 - 9;
                 if (i * 2 + 1 < armorValue)
                 {
                     // Full armor icon
@@ -59,9 +59,9 @@ public class HudComponentArmorBar
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
@@ -69,7 +69,7 @@ public class HudComponentArmorBar
 
         int armorValue = 11;
         for (int i = 0; i < 10; i++) {
-            int xArmor = x + getXSize(mc) - i * 8 - 9;
+            int xArmor = x + getXSize() - i * 8 - 9;
             if (i * 2 + 1 < armorValue)
             {
                 // Full armor icon
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
new file mode 100644
index 000000000..701149499
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentArmorDurability.java
@@ -0,0 +1,93 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+
+import static org.lwjgl.opengl.GL11.*;
+
+public class HudComponentArmorDurability
+    extends HudComponentMovable
+{
+    private static final ItemStack[] PREVIEW_STACKS = new ItemStack[] {
+            Items.ARMOR_HELMET_DIAMOND.getDefaultStack(),
+            Items.ARMOR_CHESTPLATE_DIAMOND.getDefaultStack(),
+            Items.ARMOR_LEGGINGS_DIAMOND.getDefaultStack(),
+            Items.ARMOR_BOOTS_DIAMOND.getDefaultStack(),
+    };
+
+    public HudComponentArmorDurability(String key, Layout layout) {
+        super(key, 64, 64, layout);
+    }
+
+    @Override
+    public boolean isVisible() {
+        return mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.armorDurabilityOverlay.value;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return mc.gameSettings.armorDurabilityOverlay.value;
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        for (int i = mc.thePlayer.getNumArmorSlots() - 1; i >= 0; i--)
+        {
+            ItemStack stack = mc.thePlayer.getItemInArmorSlot(HumanArmorShape.values()[i]);
+
+            if (stack != null)
+            {
+                int xx = x + 2;
+                int yy = y + i * 16;
+                ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(Tessellator.instance, null, stack, xx, yy, 1f, 1.0f, partialTick);
+                glDisable(GL_LIGHTING);
+
+                if (stack.isItemStackDamageable())
+                {
+                    float durability = (stack.getMaxDamage() - stack.getMetadata()) / (float) stack.getMaxDamage();
+
+                    int l = (int) (durability * 255);
+                    final int i1 = 255 - l << 16 | l << 8;
+
+                    mc.font.render(Tessellator.instance, String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), xx + 20, yy + 4).setShadow().setColor(i1).call();
+                }
+            }
+        }
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        for (int i = PREVIEW_STACKS.length - 1; i >= 0; i--)
+        {
+            ItemStack stack = PREVIEW_STACKS[i];
+
+            int xx = x + 2;
+            int yy = y + i * 16;
+            ItemModelDispatcher.getInstance().getDispatch(stack).renderGui(Tessellator.instance, null, stack, xx, yy, 1f, 1.0f, 0.0f);
+            glDisable(GL_LIGHTING);
+
+            if (stack.isItemStackDamageable())
+            {
+                float durability = (stack.getMaxDamage() - stack.getMetadata()) / (float) stack.getMaxDamage();
+
+                int l = (int) (durability * 255);
+                final int i1 = 255 - l << 16 | l << 8;
+
+                mc.font.render(Tessellator.instance, String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), xx + 20, yy + 4).setShadow().setColor(i1).call();
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentCrosshair.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentCrosshair.java
index 58fa0ec12..12d145ef3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentCrosshair.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentCrosshair.java
@@ -14,14 +14,14 @@ public class HudComponentCrosshair
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.immersiveMode.drawCrosshair() && mc.gameSettings.thirdPersonView.value == 0;
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
@@ -34,9 +34,9 @@ public class HudComponentCrosshair
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup crosshair texture
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
index b1736f267..89ea81875 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentFireBar.java
@@ -14,14 +14,14 @@ public class HudComponentFireBar
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.immersiveMode.drawHotbar() && mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.thePlayer.remainingFireTicks > 0;
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
@@ -36,9 +36,9 @@ public class HudComponentFireBar
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
index 4551275df..8eb71cb96 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHealthBar.java
@@ -26,14 +26,14 @@ public class HudComponentHealthBar
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.playerController.canHurtPlayer() && !mc.thePlayer.getGamemode().isPlayerInvulnerable() && mc.gameSettings.immersiveMode.drawHotbar();
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
@@ -118,9 +118,9 @@ public class HudComponentHealthBar
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup rendering
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
new file mode 100644
index 000000000..ad85cf818
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHeldItemCount.java
@@ -0,0 +1,111 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+
+import java.awt.*;
+
+public class HudComponentHeldItemCount
+    extends HudComponentMovable
+{
+    private static final ItemStack PREVIEW_ITEM = new ItemStack(Blocks.COBBLE_BASALT, 53);
+
+    public HudComponentHeldItemCount(String key, Layout layout) {
+        super(key, 53, 22, layout);
+    }
+
+    @Override
+    public boolean isVisible() {
+        return mc.gameSettings.immersiveMode.drawOverlays() && mc.gameSettings.heldItemCountOverlay.value;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return mc.gameSettings.heldItemCountOverlay.value;
+    }
+
+    @Override
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        int xx = x + 3;
+        int yy = y + 3;
+
+        ItemStack heldItemStack = mc.thePlayer.inventory.getCurrentItem();
+        if (heldItemStack != null)
+        {
+            boolean renderItem;
+
+            if (heldItemStack.isItemStackDamageable())
+            {
+                renderItem = true;
+                float durability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) / (float) heldItemStack.getMaxDamage();
+
+                final int color = 0xFF000000 + Color.HSBtoRGB(durability/3F, 1f, 1f);
+                int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
+                mc.font.render(Tessellator.instance, remainingDurability, xx + 18, yy + 4).setShadow().setColor(color).call();
+            }
+            else
+            {
+                int itemCount = 0;
+                int stackCount = 0;
+                for (int i = 0; i < mc.thePlayer.inventory.getContainerSize(); i++)
+                {
+                    ItemStack itemStack = mc.thePlayer.inventory.getItem(i);
+                    if (itemStack != null && itemStack.itemID == heldItemStack.itemID && itemStack.getMetadata() == heldItemStack.getMetadata())
+                    {
+                        itemCount += itemStack.stackSize;
+                        stackCount++;
+                    }
+                }
+                renderItem = stackCount >= 1;
+
+                if (renderItem)
+                {
+                    mc.font.render(Tessellator.instance, itemCount, xx + 18, yy + 4).setShadow().setColor(0xFFFFFFFF).call();
+                }
+            }
+
+            if (renderItem)
+            {
+                GL11.glEnable(GL11.GL_DEPTH_TEST);
+                GL11.glDisable(GL11.GL_BLEND);
+                GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+                Lighting.enableInventoryLight();
+                ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(Tessellator.instance, null, heldItemStack, xx, yy, 1f, 1f, partialTick);
+                Lighting.disable();
+            }
+        }
+    }
+
+    @Override
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
+
+        int xx = x + 3;
+        int yy = y + 3;
+
+        ItemStack heldItemStack = PREVIEW_ITEM;
+        int itemCount = heldItemStack.stackSize;
+
+        mc.font.render(Tessellator.instance, itemCount, xx + 18, yy + 4).setShadow().setColor(0xFFFFFFFF).call();
+
+        GL11.glEnable(GL11.GL_DEPTH_TEST);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        Lighting.enableInventoryLight();
+        ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderGui(Tessellator.instance, null, heldItemStack, xx, yy, 1f, 1f, 0.0f);
+        Lighting.disable();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 0264d808b..6f86881da 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -49,14 +49,14 @@ public class HudComponentHotbar
     }
 
     @Override
-    public boolean isVisible(Minecraft mc) {
+    public boolean isVisible() {
         return mc.gameSettings.immersiveMode.drawHotbar();
     }
 
     @Override
-    public void render(Minecraft mc, HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
-        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
-        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+    public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        int x = this.getLayout().getComponentX(this, xSizeScreen);
+        int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         ContainerInventory inv = mc.thePlayer.inventory;
 
@@ -145,9 +145,9 @@ public class HudComponentHotbar
     }
 
     @Override
-    public void renderPreview(Minecraft mc, Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
-        int x = layout.getComponentX(mc, this, xSizeScreen);
-        int y = layout.getComponentY(mc, this, ySizeScreen);
+    public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
+        int x = layout.getComponentX(this, xSizeScreen);
+        int y = layout.getComponentY(this, ySizeScreen);
 
         // Setup hotbar texture
         GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
